module Hermes
  module RexClient
    class UpdateStructureTask

      def update_entity(rex_entity, className, client = Hermes::RexClient::Client.new, dont_update_parent = true,  arbo_ids = [], already_updated_parent = false)
        fields = rex_entity['fields']
        return if fields['id_cristal'].blank?

        arbo_ids << fields['id_cristal']
        structure = className.constantize.find_by(id_cristal: fields['id_cristal'])

        if !structure
          structure = className.constantize.create(generate_structure_fields(fields, rex_entity['id']))
        else
          structure.update(generate_structure_fields(fields, rex_entity['id']))
        end

        if !fields['id_parent_cristal'].blank? && !arbo_ids.include?(fields['id_parent_cristal'])
          parent = className.constantize.find_by(id_cristal: fields['id_parent_cristal'])
          if !already_updated_parent && (!dont_update_parent || !parent)
            parent_rex_entity = client.search_structures({"fields.id_cristal": "|#{fields['id_parent_cristal']}"}).first
            parent = update_entity(parent_rex_entity, className, client, dont_update_parent, arbo_ids, true) if parent_rex_entity
          end
          structure.parent_id = parent.id if parent
        end
        
        structure.save!
        structure
      end

      def generate_structure_fields(fields , id)      
        {
          title: fields['app_comm'],
          id_rex: id,
          id_cristal: fields['id_cristal'],
          id_parent_cristal: fields['id_parent_cristal'],
          siret: fields['siret'].length == 14 ? fields['siret'] : nil,
        }
      end
    end
  end
end
